Sql Virtual Machines - Get
Gets a SQL virtual machine.
GET https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.SqlVirtualMachine/sqlVirtualMachines/{sqlVirtualMachineName}?api-version=2023-10-01
GET https://management.azure.com/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/Microsoft.SqlVirtualMachine/sqlVirtualMachines/{sqlVirtualMachineName}?api-version=2023-10-01&$expand={$expand}
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
resource
|
path | True |
string minLength: 1maxLength: 90 |
The name of the resource group. The name is case insensitive. |
|
sql
|
path | True |
string minLength: 1maxLength: 64 pattern: ^((?!_)[^\\/"'\[\]:|<>+=;,?*@&]{1,64}(? |
Name of the SQL virtual machine. |
|
subscription
|
path | True |
string minLength: 1 |
The ID of the target subscription. |
|
api-version
|
query | True |
string minLength: 1 |
The API version to use for this operation. |
|
$expand
|
query |
string |
The child resources to include in the response. |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
Azure operation completed successfully. |
|
| Other Status Codes |
An unexpected error response. |
Security
azure_auth
Azure Active Directory OAuth2 Flow.
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name | Description |
|---|---|
| user_impersonation | impersonate your user account |
Examples
Gets a SQL virtual machine.
Sample request
GET https://management.azure.com/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/testrg/providers/Microsoft.SqlVirtualMachine/sqlVirtualMachines/testvm?api-version=2023-10-01
Sample response
{
"name": "testvm",
"type": "Microsoft.SqlVirtualMachine/sqlVirtualMachines",
"id": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/testrg/providers/Microsoft.SqlVirtualMachine/sqlVirtualMachines/testvm",
"location": "northeurope",
"properties": {
"additionalVmPatch": "WU",
"enableAutomaticUpgrade": true,
"leastPrivilegeMode": "Enabled",
"osType": "Windows",
"provisioningState": "Succeeded",
"sqlImageOffer": "SQL2022-WS2022",
"sqlImageSku": "Enterprise",
"sqlManagement": "Full",
"sqlServerLicenseType": "PAYG",
"virtualMachineIdentitySettings": {
"type": "SystemAssigned"
},
"virtualMachineResourceId": "/subscriptions/00000000-1111-2222-3333-444444444444/resourceGroups/testrg/providers/Microsoft.Compute/virtualMachines/testvm"
}
}
Definitions
| Name | Description |
|---|---|
|
AADAuthentication |
Enable AAD authentication for SQL VM. |
|
Additional |
Additional SQL Server feature settings. |
|
Additional |
Additional VM Patching solution enabled on the Virtual Machine |
|
Additional |
Additional Patch to be enable or enabled on the SQL Virtual Machine. |
|
Assessment |
Day of the week to run assessment. |
|
Assessment |
Configure SQL best practices Assessment for databases in your SQL virtual machine. |
|
Auto |
|
|
Auto |
Configure backups for databases in your SQL virtual machine. |
|
Auto |
Set a patching window during which Windows and SQL patches will be applied. |
|
Backup |
Backup schedule type. |
|
Connectivity |
SQL Server connectivity option. |
|
created |
The type of identity that created the resource. |
|
Day |
Day of week to apply the patch on. |
|
Disk |
Disk configuration to apply to SQL Server. |
|
Error |
The resource management error additional info. |
|
Error |
The error detail. |
|
Error |
Error response |
|
Full |
Frequency of full backups. In both cases, full backups begin during the next scheduled time window. |
|
Identity |
The identity type. Set this to 'SystemAssigned' in order to automatically create and assign an Azure Active Directory principal for the resource. |
|
Key |
Configure your SQL virtual machine to be able to connect to the Azure Key Vault service. |
|
Least |
SQL IaaS Agent least privilege mode. |
|
Os |
Operating System of the current SQL Virtual Machine. |
|
Resource |
Azure Active Directory identity configuration for a resource. |
| Schedule |
Set assessment schedule for SQL Server. |
|
Server |
Set the connectivity, storage and workload settings. |
|
Sql |
Set the access level and network port settings for SQL Server. |
|
Sql |
SQL Server edition type. |
|
SQLInstance |
Set the server/instance-level settings for SQL Server. |
|
Sql |
SQL Server Management type. NOTE: This parameter is not used anymore. API will automatically detect the Sql Management, refrain from using it. |
|
Sql |
SQL Server license type. |
|
SQLStorage |
Set disk storage settings for SQL Server. |
|
Sql |
Set disk storage settings for SQL Server. |
|
SQLTemp |
Set tempDb storage settings for SQL Server. |
|
Sql |
A SQL virtual machine. |
|
Sql |
SQL Server workload type. |
|
Sql |
Set workload type to optimize storage for SQL Server. |
|
Storage |
Storage Configurations for SQL Data, Log and TempDb. |
|
Storage |
Storage workload type. |
|
system |
Metadata pertaining to creation and last modification of the resource. |
|
Troubleshooting |
SQL VM Troubleshooting additional properties. |
|
Troubleshooting |
SQL VM troubleshooting scenario. |
|
Troubleshooting |
Status of last troubleshooting operation on this SQL VM |
|
Unhealthy |
SQL VM Troubleshoot UnhealthyReplica scenario information. |
|
Virtual |
Virtual Machine Identity details used for Sql IaaS extension configurations. |
|
Vm |
Identity type of the virtual machine. Specify None to opt-out of Managed Identities. |
|
Wsfc |
Domain credentials for setting up Windows Server Failover Cluster for SQL availability group. |
AADAuthenticationSettings
Enable AAD authentication for SQL VM.
| Name | Type | Description |
|---|---|---|
| clientId |
string |
The client Id of the Managed Identity to query Microsoft Graph API. An empty string must be used for the system assigned Managed Identity |
AdditionalFeaturesServerConfigurations
Additional SQL Server feature settings.
| Name | Type | Description |
|---|---|---|
| isRServicesEnabled |
boolean |
Enable or disable R services (SQL 2016 onwards). |
AdditionalOsPatch
Additional VM Patching solution enabled on the Virtual Machine
| Value | Description |
|---|---|
| WU | |
| WUMU | |
| WSUS |
AdditionalVmPatch
Additional Patch to be enable or enabled on the SQL Virtual Machine.
| Value | Description |
|---|---|
| NotSet | |
| MicrosoftUpdate |
AssessmentDayOfWeek
Day of the week to run assessment.
| Value | Description |
|---|---|
| Monday | |
| Tuesday | |
| Wednesday | |
| Thursday | |
| Friday | |
| Saturday | |
| Sunday |
AssessmentSettings
Configure SQL best practices Assessment for databases in your SQL virtual machine.
| Name | Type | Description |
|---|---|---|
| enable |
boolean |
Enable or disable SQL best practices Assessment feature on SQL virtual machine. |
| runImmediately |
boolean |
Run SQL best practices Assessment immediately on SQL virtual machine. |
| schedule |
Schedule for SQL best practices Assessment. |
AutoBackupDaysOfWeek
| Value | Description |
|---|---|
| Monday | |
| Tuesday | |
| Wednesday | |
| Thursday | |
| Friday | |
| Saturday | |
| Sunday |
AutoBackupSettings
Configure backups for databases in your SQL virtual machine.
| Name | Type | Description |
|---|---|---|
| backupScheduleType |
Backup schedule type. |
|
| backupSystemDbs |
boolean |
Include or exclude system databases from auto backup. |
| daysOfWeek |
Days of the week for the backups when FullBackupFrequency is set to Weekly. |
|
| enable |
boolean |
Enable or disable autobackup on SQL virtual machine. |
| enableEncryption |
boolean |
Enable or disable encryption for backup on SQL virtual machine. |
| fullBackupFrequency |
Frequency of full backups. In both cases, full backups begin during the next scheduled time window. |
|
| fullBackupStartTime |
integer (int32) |
Start time of a given day during which full backups can take place. 0-23 hours. |
| fullBackupWindowHours |
integer (int32) |
Duration of the time window of a given day during which full backups can take place. 1-23 hours. |
| logBackupFrequency |
integer (int32) |
Frequency of log backups. 5-60 minutes. |
| password |
string |
Password for encryption on backup. |
| retentionPeriod |
integer (int32) |
Retention period of backup: 1-90 days. |
| storageAccessKey |
string |
Storage account key where backup will be taken to. |
| storageAccountUrl |
string |
Storage account url where backup will be taken to. |
| storageContainerName |
string |
Storage container name where backup will be taken to. |
AutoPatchingSettings
Set a patching window during which Windows and SQL patches will be applied.
| Name | Type | Default value | Description |
|---|---|---|---|
| additionalVmPatch | NotSet |
Additional Patch to be enable or enabled on the SQL Virtual Machine. |
|
| dayOfWeek |
Day of week to apply the patch on. |
||
| enable |
boolean |
Enable or disable autopatching on SQL virtual machine. |
|
| maintenanceWindowDuration |
integer (int32) |
Duration of patching. |
|
| maintenanceWindowStartingHour |
integer (int32) |
Hour of the day when patching is initiated. Local VM time. |
BackupScheduleType
Backup schedule type.
| Value | Description |
|---|---|
| Manual | |
| Automated |
ConnectivityType
SQL Server connectivity option.
| Value | Description |
|---|---|
| LOCAL | |
| PRIVATE | |
| PUBLIC |
createdByType
The type of identity that created the resource.
| Value | Description |
|---|---|
| User | |
| Application | |
| ManagedIdentity | |
| Key |
DayOfWeek
Day of week to apply the patch on.
| Value | Description |
|---|---|
| Everyday | |
| Monday | |
| Tuesday | |
| Wednesday | |
| Thursday | |
| Friday | |
| Saturday | |
| Sunday |
DiskConfigurationType
Disk configuration to apply to SQL Server.
| Value | Description |
|---|---|
| NEW | |
| EXTEND | |
| ADD |
ErrorAdditionalInfo
The resource management error additional info.
| Name | Type | Description |
|---|---|---|
| info |
object |
The additional info. |
| type |
string |
The additional info type. |
ErrorDetail
The error detail.
| Name | Type | Description |
|---|---|---|
| additionalInfo |
The error additional info. |
|
| code |
string |
The error code. |
| details |
The error details. |
|
| message |
string |
The error message. |
| target |
string |
The error target. |
ErrorResponse
Error response
| Name | Type | Description |
|---|---|---|
| error |
The error object. |
FullBackupFrequencyType
Frequency of full backups. In both cases, full backups begin during the next scheduled time window.
| Value | Description |
|---|---|
| Daily | |
| Weekly |
IdentityType
The identity type. Set this to 'SystemAssigned' in order to automatically create and assign an Azure Active Directory principal for the resource.
| Value | Description |
|---|---|
| None | |
| SystemAssigned | |
| UserAssigned | |
| SystemAssigned,UserAssigned |
KeyVaultCredentialSettings
Configure your SQL virtual machine to be able to connect to the Azure Key Vault service.
| Name | Type | Description |
|---|---|---|
| azureKeyVaultUrl |
string |
Azure Key Vault url. |
| credentialName |
string |
Credential name. |
| enable |
boolean |
Enable or disable key vault credential setting. |
| servicePrincipalName |
string |
Service principal name to access key vault. |
| servicePrincipalSecret |
string |
Service principal name secret to access key vault. |
LeastPrivilegeMode
SQL IaaS Agent least privilege mode.
| Value | Description |
|---|---|
| Enabled | |
| NotSet |
OsType
Operating System of the current SQL Virtual Machine.
| Value | Description |
|---|---|
| Windows | |
| Linux |
ResourceIdentity
Azure Active Directory identity configuration for a resource.
| Name | Type | Description |
|---|---|---|
| principalId |
string (uuid) |
The Azure Active Directory principal id. |
| tenantId |
string (uuid) |
The Azure Active Directory tenant id. |
| type |
The identity type. Set this to 'SystemAssigned' in order to automatically create and assign an Azure Active Directory principal for the resource. |
Schedule
Set assessment schedule for SQL Server.
| Name | Type | Description |
|---|---|---|
| dayOfWeek |
Day of the week to run assessment. |
|
| enable |
boolean |
Enable or disable assessment schedule on SQL virtual machine. |
| monthlyOccurrence |
integer (int32) |
Occurrence of the DayOfWeek day within a month to schedule assessment. Takes values: 1,2,3,4 and -1. Use -1 for last DayOfWeek day of the month |
| startTime |
string |
Time of the day in HH:mm format. Eg. 17:30 |
| weeklyInterval |
integer (int32) |
Number of weeks to schedule between 2 assessment runs. Takes value from 1-6 |
ServerConfigurationsManagementSettings
Set the connectivity, storage and workload settings.
| Name | Type | Description |
|---|---|---|
| additionalFeaturesServerConfigurations |
Additional SQL feature settings. |
|
| azureAdAuthenticationSettings |
Azure AD authentication Settings. |
|
| sqlConnectivityUpdateSettings |
SQL connectivity type settings. |
|
| sqlInstanceSettings |
SQL Instance settings. |
|
| sqlStorageUpdateSettings |
SQL storage update settings. |
|
| sqlWorkloadTypeUpdateSettings |
SQL workload type settings. |
SqlConnectivityUpdateSettings
Set the access level and network port settings for SQL Server.
| Name | Type | Description |
|---|---|---|
| connectivityType |
SQL Server connectivity option. |
|
| port |
integer (int32) |
SQL Server port. |
| sqlAuthUpdatePassword |
string |
SQL Server sysadmin login password. |
| sqlAuthUpdateUserName |
string |
SQL Server sysadmin login to create. |
SqlImageSku
SQL Server edition type.
| Value | Description |
|---|---|
| Developer | |
| Express | |
| Standard | |
| Enterprise | |
| Web |
SQLInstanceSettings
Set the server/instance-level settings for SQL Server.
| Name | Type | Description |
|---|---|---|
| collation |
string |
SQL Server Collation. |
| isIfiEnabled |
boolean |
SQL Server IFI. |
| isLpimEnabled |
boolean |
SQL Server LPIM. |
| isOptimizeForAdHocWorkloadsEnabled |
boolean |
SQL Server Optimize for Adhoc workloads. |
| maxDop |
integer (int32) |
SQL Server MAXDOP. |
| maxServerMemoryMB |
integer (int32) |
SQL Server maximum memory. |
| minServerMemoryMB |
integer (int32) |
SQL Server minimum memory. |
SqlManagementMode
SQL Server Management type. NOTE: This parameter is not used anymore. API will automatically detect the Sql Management, refrain from using it.
| Value | Description |
|---|---|
| Full | |
| LightWeight | |
| NoAgent |
SqlServerLicenseType
SQL Server license type.
| Value | Description |
|---|---|
| PAYG | |
| AHUB | |
| DR |
SQLStorageSettings
Set disk storage settings for SQL Server.
| Name | Type | Description |
|---|---|---|
| defaultFilePath |
string |
SQL Server default file path |
| luns |
integer[] (int32) |
Logical Unit Numbers for the disks. |
| useStoragePool |
boolean |
Use storage pool to build a drive if true or not provided |
SqlStorageUpdateSettings
Set disk storage settings for SQL Server.
| Name | Type | Description |
|---|---|---|
| diskConfigurationType |
Disk configuration to apply to SQL Server. |
|
| diskCount |
integer (int32) |
Virtual machine disk count. |
| startingDeviceId |
integer (int32) |
Device id of the first disk to be updated. |
SQLTempDbSettings
Set tempDb storage settings for SQL Server.
| Name | Type | Description |
|---|---|---|
| dataFileCount |
integer (int32) |
SQL Server tempdb data file count |
| dataFileSize |
integer (int32) |
SQL Server tempdb data file size |
| dataGrowth |
integer (int32) |
SQL Server tempdb data file autoGrowth size |
| defaultFilePath |
string |
SQL Server default file path |
| logFileSize |
integer (int32) |
SQL Server tempdb log file size |
| logGrowth |
integer (int32) |
SQL Server tempdb log file autoGrowth size |
| luns |
integer[] (int32) |
Logical Unit Numbers for the disks. |
| persistFolder |
boolean |
SQL Server tempdb persist folder choice |
| persistFolderPath |
string |
SQL Server tempdb persist folder location |
| useStoragePool |
boolean |
Use storage pool to build a drive if true or not provided |
SqlVirtualMachine
A SQL virtual machine.
| Name | Type | Default value | Description |
|---|---|---|---|
| id |
string |
Fully qualified resource ID for the resource. Ex - /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName} |
|
| identity |
DO NOT USE. This value will be deprecated. Azure Active Directory identity of the server. |
||
| location |
string |
The geo-location where the resource lives |
|
| name |
string |
The name of the resource |
|
| properties.additionalVmPatch |
Additional VM Patching solution enabled on the Virtual Machine |
||
| properties.assessmentSettings |
SQL best practices Assessment Settings. |
||
| properties.autoBackupSettings |
Auto backup settings for SQL Server. |
||
| properties.autoPatchingSettings |
Auto patching settings for applying critical security updates to SQL virtual machine. |
||
| properties.enableAutomaticUpgrade |
boolean |
False |
Enable automatic upgrade of Sql IaaS extension Agent. |
| properties.keyVaultCredentialSettings |
Key vault credential settings. |
||
| properties.leastPrivilegeMode | NotSet |
SQL IaaS Agent least privilege mode. |
|
| properties.osType |
Operating System of the current SQL Virtual Machine. |
||
| properties.provisioningState |
string |
Provisioning state to track the async operation status. |
|
| properties.serverConfigurationsManagementSettings |
SQL Server configuration management settings. |
||
| properties.sqlImageOffer |
string |
SQL image offer. Examples include SQL2016-WS2016, SQL2017-WS2016. |
|
| properties.sqlImageSku |
SQL Server edition type. |
||
| properties.sqlManagement |
SQL Server Management type. NOTE: This parameter is not used anymore. API will automatically detect the Sql Management, refrain from using it. |
||
| properties.sqlServerLicenseType |
SQL Server license type. |
||
| properties.sqlVirtualMachineGroupResourceId |
string |
ARM resource id of the SQL virtual machine group this SQL virtual machine is or will be part of. |
|
| properties.storageConfigurationSettings |
Storage Configuration Settings. |
||
| properties.troubleshootingStatus |
Troubleshooting status |
||
| properties.virtualMachineIdentitySettings |
Virtual Machine Identity details used for Sql IaaS extension configurations. |
||
| properties.virtualMachineResourceId |
string |
ARM Resource id of underlying virtual machine created from SQL marketplace image. |
|
| properties.wsfcDomainCredentials |
Domain credentials for setting up Windows Server Failover Cluster for SQL availability group. |
||
| properties.wsfcStaticIp |
string |
Domain credentials for setting up Windows Server Failover Cluster for SQL availability group. |
|
| systemData |
Azure Resource Manager metadata containing createdBy and modifiedBy information. |
||
| tags |
object |
Resource tags. |
|
| type |
string |
The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts" |
SqlWorkloadType
SQL Server workload type.
| Value | Description |
|---|---|
| GENERAL | |
| OLTP | |
| DW |
SqlWorkloadTypeUpdateSettings
Set workload type to optimize storage for SQL Server.
| Name | Type | Description |
|---|---|---|
| sqlWorkloadType |
SQL Server workload type. |
StorageConfigurationSettings
Storage Configurations for SQL Data, Log and TempDb.
| Name | Type | Default value | Description |
|---|---|---|---|
| diskConfigurationType |
Disk configuration to apply to SQL Server. |
||
| enableStorageConfigBlade |
boolean |
False |
Enable SQL IaaS Agent storage configuration blade in Azure Portal. |
| sqlDataSettings |
SQL Server Data Storage Settings. |
||
| sqlLogSettings |
SQL Server Log Storage Settings. |
||
| sqlSystemDbOnDataDisk |
boolean |
SQL Server SystemDb Storage on DataPool if true. |
|
| sqlTempDbSettings |
SQL Server TempDb Storage Settings. |
||
| storageWorkloadType |
Storage workload type. |
StorageWorkloadType
Storage workload type.
| Value | Description |
|---|---|
| GENERAL | |
| OLTP | |
| DW |
systemData
Metadata pertaining to creation and last modification of the resource.
| Name | Type | Description |
|---|---|---|
| createdAt |
string (date-time) |
The timestamp of resource creation (UTC). |
| createdBy |
string |
The identity that created the resource. |
| createdByType |
The type of identity that created the resource. |
|
| lastModifiedAt |
string (date-time) |
The timestamp of resource last modification (UTC) |
| lastModifiedBy |
string |
The identity that last modified the resource. |
| lastModifiedByType |
The type of identity that last modified the resource. |
TroubleshootingAdditionalProperties
SQL VM Troubleshooting additional properties.
| Name | Type | Description |
|---|---|---|
| unhealthyReplicaInfo |
The unhealthy replica information |
TroubleshootingScenario
SQL VM troubleshooting scenario.
| Value | Description |
|---|---|
| UnhealthyReplica |
TroubleshootingStatus
Status of last troubleshooting operation on this SQL VM
| Name | Type | Default value | Description |
|---|---|---|---|
| endTimeUtc |
string (date-time) |
End time in UTC timezone. |
|
| lastTriggerTimeUtc |
string (date-time) |
Last troubleshooting trigger time in UTC timezone |
|
| properties |
Troubleshooting properties |
||
| rootCause |
string |
Root cause of the issue |
|
| startTimeUtc |
string (date-time) |
Start time in UTC timezone. |
|
| troubleshootingScenario | UnhealthyReplica |
SQL VM troubleshooting scenario. |
UnhealthyReplicaInfo
SQL VM Troubleshoot UnhealthyReplica scenario information.
| Name | Type | Description |
|---|---|---|
| availabilityGroupName |
string |
The name of the availability group |
VirtualMachineIdentity
Virtual Machine Identity details used for Sql IaaS extension configurations.
| Name | Type | Description |
|---|---|---|
| resourceId |
string (arm-id) |
ARM Resource Id of the identity. Only required when UserAssigned identity is selected. |
| type |
Identity type of the virtual machine. Specify None to opt-out of Managed Identities. |
VmIdentityType
Identity type of the virtual machine. Specify None to opt-out of Managed Identities.
| Value | Description |
|---|---|
| None | |
| SystemAssigned | |
| UserAssigned |
WsfcDomainCredentials
Domain credentials for setting up Windows Server Failover Cluster for SQL availability group.
| Name | Type | Description |
|---|---|---|
| clusterBootstrapAccountPassword |
string |
Cluster bootstrap account password. |
| clusterOperatorAccountPassword |
string |
Cluster operator account password. |
| sqlServiceAccountPassword |
string |
SQL service account password. |